"use strict";
/*!
 * drslib
 * Apache Licence 2.0
 * https://github.com/cocop/drslib/blob/master/LICENSE
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Type parameter is indistinguishable
 * @param arg True if the instance implements IAction
 */
function isIAction(arg) {
    return arg
        && typeof arg === "object"
        && typeof arg.do === "function";
}
exports.isIAction = isIAction;
var async = function (syncable) { return __awaiter(_this, void 0, void 0, function () {
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!(syncable instanceof Promise)) return [3 /*break*/, 2];
                return [4 /*yield*/, syncable];
            case 1:
                _a = _b.sent();
                return [3 /*break*/, 3];
            case 2:
                _a = syncable;
                _b.label = 3;
            case 3: return [2 /*return*/, _a];
        }
    });
}); };
/* ------------------------ */
/**
 * base class for common constructor
 */
var BAction = /** @class */ (function () {
    function BAction(values) {
        this.$ = values;
    }
    return BAction;
}());
exports.BAction = BAction;
/**
 * base class for action accept constructor
 */
var BOuter = /** @class */ (function () {
    function BOuter(inner) {
        this._inner = inner;
    }
    return BOuter;
}());
exports.BOuter = BOuter;
/* ------------------------ */
/**
 * execute function
 */
var Run = /** @class */ (function () {
    function Run(func) {
        this._func = func;
    }
    Run.prototype.do = function (param) {
        return this._func(param);
    };
    return Run;
}());
exports.Run = Run;
/**
 * execute getting function
 */
var Get = /** @class */ (function () {
    function Get(ref) {
        this._ref = ref;
    }
    Get.prototype.do = function (param) {
        if (typeof (this._ref) === "function") {
            return this._ref();
        }
        else {
            return this._ref.get();
        }
    };
    return Get;
}());
exports.Get = Get;
/**
 * execute setting function
 */
var Set = /** @class */ (function () {
    function Set(ref) {
        this._ref = ref;
    }
    Set.prototype.do = function (param) {
        if (typeof (this._ref) === "function") {
            this._ref(param);
        }
        else {
            this._ref.set(param);
        }
    };
    return Set;
}());
exports.Set = Set;
/**
 * If isDo is true, execute inner
 */
var IfValid = /** @class */ (function (_super) {
    __extends(IfValid, _super);
    function IfValid(isDo, inner) {
        var _this = _super.call(this, inner) || this;
        _this._isDo = isDo;
        return _this;
    }
    IfValid.prototype.do = function (param) {
        if (this._isDo.do()) {
            return this._inner.do(param);
        }
    };
    return IfValid;
}(BOuter));
exports.IfValid = IfValid;
// RunActions
/* ------------------------ */
/**
 * Actions that perform multiple actions
 */
var RunActions = /** @class */ (function () {
    function RunActions(list) {
        this._list = list;
    }
    RunActions.prototype.do = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var results, _i, _a, item, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        results = [];
                        _i = 0, _a = this._list;
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        item = _a[_i];
                        _c = (_b = results).push;
                        return [4 /*yield*/, async(item.do(param))];
                    case 2:
                        _c.apply(_b, [_d.sent()]);
                        _d.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, results];
                }
            });
        });
    };
    return RunActions;
}());
exports.RunActions = RunActions;
/**
 * An action that executes multiple actions asynchronously
 */
var RunActionsParallel = /** @class */ (function (_super) {
    __extends(RunActionsParallel, _super);
    function RunActionsParallel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RunActionsParallel.prototype.do = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(this._list.map(function (i) { return async(i.do(param)); }))];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return RunActionsParallel;
}(RunActions));
exports.RunActionsParallel = RunActionsParallel;
/**
 * Actions that perform ordered actions
 */
var RunActionsOrder = /** @class */ (function () {
    function RunActionsOrder(previous, executing, following) {
        this._previous = previous;
        this._executing = executing;
        this._following = following;
    }
    RunActionsOrder.prototype.do = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, async(this._previous.do(param))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, async(this._executing.do(param))];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, async(this._following.do(param))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    return RunActionsOrder;
}());
exports.RunActionsOrder = RunActionsOrder;
var BRunChain = /** @class */ (function () {
    function BRunChain(chain) {
        this._chain = chain;
    }
    return BRunChain;
}());
var RunChainSync = /** @class */ (function (_super) {
    __extends(RunChainSync, _super);
    function RunChainSync() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RunChainSync.prototype.do = function (param) {
        var result = param;
        for (var _i = 0, _a = this._chain; _i < _a.length; _i++) {
            var chainLink = _a[_i];
            switch (chainLink.doStatus) {
                case 1 /* JoinSync */:
                    result = chainLink.action.do(result);
                    break;
                case 3 /* PassSync */:
                    chainLink.action.do(result);
                    break;
                case 0 /* JoinAsync */:
                case 2 /* PassAsync */:
                    throw new Error("Asynchronous task called in synchronous runner");
            }
        }
        return result;
    };
    return RunChainSync;
}(BRunChain));
var RunChainAsync = /** @class */ (function (_super) {
    __extends(RunChainAsync, _super);
    function RunChainAsync() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RunChainAsync.prototype.do = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var result, _i, _a, chainLink, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        result = param;
                        _i = 0, _a = this._chain;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 9];
                        chainLink = _a[_i];
                        _b = chainLink.doStatus;
                        switch (_b) {
                            case 0 /* JoinAsync */: return [3 /*break*/, 2];
                            case 2 /* PassAsync */: return [3 /*break*/, 4];
                            case 1 /* JoinSync */: return [3 /*break*/, 6];
                            case 3 /* PassSync */: return [3 /*break*/, 7];
                        }
                        return [3 /*break*/, 8];
                    case 2: return [4 /*yield*/, async(chainLink.action.do(result))];
                    case 3:
                        result = _c.sent();
                        return [3 /*break*/, 8];
                    case 4: return [4 /*yield*/, async(chainLink.action.do(result))];
                    case 5:
                        _c.sent();
                        return [3 /*break*/, 8];
                    case 6:
                        result = chainLink.action.do(result);
                        return [3 /*break*/, 8];
                    case 7:
                        chainLink.action.do(result);
                        return [3 /*break*/, 8];
                    case 8:
                        _i++;
                        return [3 /*break*/, 1];
                    case 9: return [2 /*return*/, result];
                }
            });
        });
    };
    return RunChainAsync;
}(BRunChain));
var BChainLink = /** @class */ (function () {
    function BChainLink(chain) {
        this._chain = chain;
    }
    BChainLink.prototype.join = function (action) {
        this._chain.push({
            doStatus: 1 /* JoinSync */,
            action: action
        });
        return this;
    };
    BChainLink.prototype.pass = function (action) {
        this._chain.push({
            doStatus: 3 /* PassSync */,
            action: action
        });
        return this;
    };
    BChainLink.prototype.joinWait = function (action) {
        this._chain.push({
            doStatus: 0 /* JoinAsync */,
            action: action
        });
        return this;
    };
    BChainLink.prototype.passWait = function (action) {
        this._chain.push({
            doStatus: 2 /* PassAsync */,
            action: action
        });
        return this;
    };
    return BChainLink;
}());
var SyncChainLink = /** @class */ (function (_super) {
    __extends(SyncChainLink, _super);
    function SyncChainLink() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Create action
     */
    SyncChainLink.prototype.create = function () {
        return new RunChainSync(this._chain);
    };
    /**
     * Set an action that accepts a parameter and returns the next parameter
     * @param action An action that accepts a parameter and returns the next parameter
     */
    SyncChainLink.prototype.join = function (action) {
        return _super.prototype.join.call(this, action);
    };
    /**
     * Set an action that accepts parameters
     * @param action Action that accepts parameters
     */
    SyncChainLink.prototype.pass = function (action) {
        return _super.prototype.pass.call(this, action);
    };
    /**
     * Sets an asynchronous action that accepts parameters and returns the next parameter
     *     Calling this method makes the action created asynchronous
     * @param action Asynchronous action that accepts a parameter and returns the next parameter
     */
    SyncChainLink.prototype.joinWait = function (action) {
        _super.prototype.joinWait.call(this, action);
        return new AsyncChainLink(this._chain);
    };
    /**
     * Set an asynchronous action that accepts parameters
     *     Calling this method makes the action created asynchronous
     * @param action Asynchronous actions that accept parameters
     */
    SyncChainLink.prototype.passWait = function (action) {
        _super.prototype.passWait.call(this, action);
        return new AsyncChainLink(this._chain);
    };
    return SyncChainLink;
}(BChainLink));
var AsyncChainLink = /** @class */ (function (_super) {
    __extends(AsyncChainLink, _super);
    function AsyncChainLink() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Create an asynchronous action
     */
    AsyncChainLink.prototype.create = function () {
        return new RunChainAsync(this._chain);
    };
    /**
     * Set an action that accepts parameters
     * @param action Action that accepts parameters
     */
    AsyncChainLink.prototype.join = function (action) {
        return _super.prototype.join.call(this, action);
    };
    /**
     * Set an action that accepts parameters
     * @param action Action that accepts parameters
     */
    AsyncChainLink.prototype.pass = function (action) {
        return _super.prototype.pass.call(this, action);
    };
    /**
     * Sets an asynchronous action that accepts parameters and returns the next parameter
     * @param action Asynchronous action that accepts a parameter and returns the next parameter
     */
    AsyncChainLink.prototype.joinWait = function (action) {
        return _super.prototype.joinWait.call(this, action);
    };
    /**
     * Set an asynchronous action that accepts parameters
     * @param action Asynchronous actions that accept parameters
     */
    AsyncChainLink.prototype.passWait = function (action) {
        return _super.prototype.passWait.call(this, action);
    };
    return AsyncChainLink;
}(BChainLink));
/**
 * A class that creates an action that pipelines the actions
 *     Use in method chain format
 */
var Chain = /** @class */ (function (_super) {
    __extends(Chain, _super);
    function Chain() {
        return _super.call(this, []) || this;
    }
    return Chain;
}(SyncChainLink));
exports.Chain = Chain;
// Repetition
/* ------------------------ */
/**
 * Action to retry until successful
 */
var Retry = /** @class */ (function (_super) {
    __extends(Retry, _super);
    function Retry(retryCount, inner) {
        var _this = _super.call(this, inner) || this;
        _this._retryCount = retryCount;
        return _this;
    }
    Retry.prototype.do = function () {
        return __awaiter(this, void 0, void 0, function () {
            var count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        count = 0;
                        _a.label = 1;
                    case 1: return [4 /*yield*/, async(this._inner.do())];
                    case 2:
                        if (!(!(_a.sent()) &&
                            count < this._retryCount)) return [3 /*break*/, 3];
                        ++count;
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Retry;
}(BOuter));
exports.Retry = Retry;
/**
 * Repeat action until it returns true
 */
var Repetition = /** @class */ (function (_super) {
    __extends(Repetition, _super);
    function Repetition() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Repetition.prototype.do = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, async(this._inner.do(param))];
                    case 1:
                        if (!!(_a.sent())) return [3 /*break*/, 2];
                        return [3 /*break*/, 0];
                    case 2:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    };
    return Repetition;
}(BOuter));
exports.Repetition = Repetition;
/**
 * Read-only context reference class
 */
var RefReader = /** @class */ (function () {
    function RefReader(get) {
        this.get = get;
    }
    return RefReader;
}());
exports.RefReader = RefReader;
/**
 * Write-only context reference class
 */
var RefWriter = /** @class */ (function () {
    function RefWriter(set) {
        this.set = set;
    }
    return RefWriter;
}());
exports.RefWriter = RefWriter;
/**
 * Context reference class
 */
var Ref = /** @class */ (function () {
    function Ref(get, set) {
        this.get = get;
        this.set = set;
    }
    return Ref;
}());
exports.Ref = Ref;
/**
 * Context reference class
 */
var RefPath = /** @class */ (function () {
    /**
     * Note that you can specify an invalid path
     * @param context Context instance
     * @param path Context path. Strings separated by "." or array
     */
    function RefPath(context, path) {
        this._context = context;
        this._path = this._pathToArray(path);
    }
    RefPath.prototype._pathToArray = function (path) {
        if (typeof path === "string") {
            return path.split(".");
        }
        return path;
    };
    RefPath.prototype.get = function () {
        var node = this._context;
        for (var i = 0; i < this._path.length; i++) {
            node = node[this._path[i]];
        }
        return node;
    };
    RefPath.prototype.set = function (value) {
        var node = this._context;
        for (var i = 0; i < this._path.length - 1; i++) {
            node = node[this._path[i]];
        }
        node[this._path[this._path.length - 1]] = value;
    };
    return RefPath;
}());
exports.RefPath = RefPath;
